<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Offices management</title>
    <script src="https://code.jquery.com/jquery-3.7.1.js"
        integrity="sha256-eKhayi8LEQwp4NKxN+CfCh+3qOVUtJn3QNZ0TciWLP4=" crossorigin="anonymous"></script>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM"
        crossorigin="anonymous"></script>

    <link rel="stylesheet" href="https://cdn.datatables.net/2.0.7/css/dataTables.bootstrap5.min.css">

    <script src="https://cdn.datatables.net/2.0.7/js/dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/2.0.7/js/dataTables.bootstrap5.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="col-md-12">
            <h2>Offices</h2>
            <table id="office" class="table table-bordered"></table>

            <a href = "task906.10.addnewoffice.form.html" class = "btn btn-success">Add new office</a>
        </div>
    </div>

    <!-- định nghĩa modal-->
    <div class="modal" tabindex="-1" id="modal">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="modalTitle">Modal title</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body" id="modalBody">
                    <p>Modal body text goes here.</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" onClick="onBtnSaveClick();">Save changes</button>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    var dataTable;
    var myModal = new bootstrap.Modal(document.getElementById('modal'));
    $(document).ready(function () {
        initTable();
        reloadTable();
        $("#office").on("click", ".btnChiTiet", function () {
            onBtnChiTietClick(this);
        })
        $("#office").on("click", ".btnSua", function () {
            onBtnSuaClick(this);
        })
        $("#office").on("click", ".btnXoa", function () {
            onBtnXoaClick(this);
        })
    });

    function onBtnSaveClick() {
        var vData = convertFormToJSON();
        vData = JSON.stringify(vData);
        $.ajax({
            url: 'offices.php',
            contentType: 'application/json',
            type: 'PUT',            
            data: vData,
            success: function (result) {
                alert("Đã sửa thành công");
                //console.log(result);
                reloadTable();
                myModal.hide();
            }
        });
    }

    function onBtnChiTietClick(paramElement) {
        var officeId = getOfficeIdFromElement(paramElement);
        //console.log (officeId);
        $("#modalTitle").html("Office detail:");

        $.get("offices.php?id=" + officeId, function (data) {
            //console.log(data);
            $("#modalBody").html(`
                ID: ${data.id}
                <br/>City: ${data.city}
                <br/>Phone: ${data.phone}
                <br/>Address line: ${data.address_line}
                <br/>State: ${data.state}
                <br/>Country: ${data.country}
            `);
            myModal.show();
        });
    }

    function onBtnXoaClick(paramElement) {
        var officeId = getOfficeIdFromElement(paramElement);
        $.ajax({
            url: 'offices.php?id=' + officeId,
            type: 'DELETE',
            success: function (result) {
                alert("Đã xóa thành công");
                reloadTable();
            }
        });
    }

    function onBtnSuaClick(paramElement) {
        var officeId = getOfficeIdFromElement(paramElement);
        $("#modalTitle").html("Edit office:");
        $.get("offices.php?id=" + officeId, function (data) {
            console.log(data);
            $("#modalBody").html(`
                <form id = "editForm">
                    
                        <input type = "hidden" name = "id" value = "${data.id}">
                        <input type = "hidden" name = "territory" value = "">
                    
                    <p>City:               
                        <br/><input type = "text" name = "city" value = "${data.city}">
                    </p>
                    <p>
                        Phone: 
                        <br/><input type = "text" name = "phone" value = "${data.phone}">
                    </p>
                    <p>
                        Address line: 
                        <br/><input type = "text" name = "address_line" value = "${data.address_line}">
                    </p>
                    <p>
                        State: 
                        <br/><input type = "text" name = "state" value = "${data.state}">
                    </p>
                    <p>
                        Country: 
                        <br/><input type = "text" name = "country" value = "${data.country}">
                    </p>
                </form>
            `);
            myModal.show();
        });
    }

    function convertFormToJSON() {
        const array = $("#editForm").serializeArray(); // Encodes the set of form elements as an array of names and values.
        const json = {};
        $.each(array, function () {
            json[this.name] = this.value || "";
        });
        return json;
    }
    function initTable() {
        dataTable = $("#office").DataTable({
            columns: [
                { data: "id" },
                { data: "city" },
                { data: "phone" },
                { data: "country" },
                { data: "action" }
            ],
            columnDefs: [
                {
                    targets: 0,
                    title: 'ID'
                },
                {
                    targets: 1,
                    title: 'City'
                },
                {
                    targets: 2,
                    title: 'Phone'
                },
                {
                    targets: 3,
                    title: 'Country'
                },
                {
                    targets: 4,
                    title: 'Action',
                    defaultContent: `
                        <button class = "btn btn-success mr-2 btnChiTiet">Chi tiết</button>
                        <button class = "btn btn-success mr-2 btnSua">Sửa</button>
                        <button class = "btn btn-success mr-2 btnXoa">Xóa</button>
                    `
                }
            ]
        });
    }
    function reloadTable() {
        $.get("offices.php", function (data) {
            dataTable.clear();
            dataTable.rows.add(data);
            dataTable.draw();
        })
    }

    function getOfficeIdFromElement(paramElement) {
        var vTr = $(paramElement).parents("tr");
        var vRow = dataTable.row(vTr);
        var vData = vRow.data();
        return vData.id;
    }
    
</script>

</html>